{- $Id: MPI.hs,v 1.1.1.2 2001/02/28 04:48:03 michaelw Exp $
 - -*- Haskell -*-
 -----------------------------------------------------------------------------
 - MPI.hs - interface to the whole functionality of the binding
 -----------------------------------------------------------------------------
 -
 - hMPI - a Haskell binding for MPI 1.1/1.2
 - Copyright (C) 2000,2001 Michael Weber <michael.weber@post.rwth-aachen.de>
 -
 - This library is free software; you can redistribute it and/or
 - modify it under the terms of the GNU Lesser General Public License
 - as published by the Free Software Foundation; either version 2 of
 - the License, or (at your option) any later version.
 - 
 - This library is distributed in the hope that it will be useful, but
 - WITHOUT ANY WARRANTY; without even the implied warranty of
 - MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 - Lesser General Public License for more details.
 - 
 - You should have received a copy of the GNU Lesser General Public
 - License along with this library; if not, write to the Free Software
 - Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 - USA
 - 
 -----------------------------------------------------------------------------
 - NOTES:                                                                      
 - * This is intended for people who want to write their own
 -   high-level routines for sending Haskell types via hMPI. No
 -   marshalling of the sent data is done. Prepare to fiddle with
 -   malloc'ed buffers. If not, use one of the {Easy,Haskell}MPI
 -   modules.
 -   
 -----------------------------------------------------------------------------
 - TODO:                                                                       
 - * document this file properly                                               
 -----------------------------------------------------------------------------
 -}

module MPI 
    ( module MPI_Manage
    , module MPI_Types
    , module MPI_Datatypes
    , module MPI_Comm
    , module MPI_Group
    , module MPI_Transfer
    , module MPI_Reduction
    , module MPI_Version
    )
where

import MPI_Manage
import MPI_Types
import MPI_Datatypes
import MPI_Comm
import MPI_Group
import MPI_Transfer
import MPI_Reduction
import MPI_Version


-------------------------------------------------------------------------------
