{- $Id: MPI_Consts.hs,v 1.1.1.2 2001/02/28 04:48:03 michaelw Exp $
 - -*- Haskell -*-
 -----------------------------------------------------------------------------
 - MPI_Consts.hs - import MPI consts into Haskell land
 -----------------------------------------------------------------------------
 -
 - hMPI - a Haskell binding for MPI 1.1/1.2
 - Copyright (C) 2000,2001 Michael Weber <michael.weber@post.rwth-aachen.de>
 -
 - This library is free software; you can redistribute it and/or
 - modify it under the terms of the GNU Lesser General Public License
 - as published by the Free Software Foundation; either version 2 of
 - the License, or (at your option) any later version.
 - 
 - This library is distributed in the hope that it will be useful, but
 - WITHOUT ANY WARRANTY; without even the implied warranty of
 - MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 - Lesser General Public License for more details.
 - 
 - You should have received a copy of the GNU Lesser General Public
 - License along with this library; if not, write to the Free Software
 - Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 - USA
 - 
 -----------------------------------------------------------------------------
 - NOTES:                                                                      
 -   
 -----------------------------------------------------------------------------
 - TODO:                                                                       
 - * document this file properly                                               
 -----------------------------------------------------------------------------
 -}

module MPI_Consts
    ( module MPI_Consts   -- everything is exported
    )
where

import MPI_MarshalInternal
import Foreign.C

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


-----------------------------------------------------------------------------
-- constants
foreign import ccall unsafe
        hmpi_max_processor_name :: Int

foreign import ccall unsafe
        hmpi_sizeof_status :: Int

foreign import ccall unsafe
        hmpi_sizeof_request :: Int


foreign import ccall unsafe
        hmpi_any_source :: MPI_Rank

foreign import ccall unsafe
        hmpi_proc_null :: MPI_Rank


foreign import ccall unsafe
        hmpi_any_tag :: MPI_Tag


foreign import ccall unsafe
        hmpi_comm_null :: MPI_Comm

foreign import ccall unsafe
        hmpi_comm_world :: MPI_Comm

foreign import ccall unsafe
        hmpi_comm_self :: MPI_Comm


foreign import ccall unsafe
        hmpi_group_empty :: MPI_Group


foreign import ccall unsafe
        hmpi_system_success :: MPI_ReturnCode


foreign import ccall unsafe
        hmpi_datatype_null :: MPI_Datatype

foreign import ccall unsafe
        hmpi_datatype_char :: MPI_Datatype

foreign import ccall unsafe
        hmpi_datatype_uchar :: MPI_Datatype

foreign import ccall unsafe
        hmpi_datatype_byte :: MPI_Datatype

foreign import ccall unsafe
        hmpi_datatype_short :: MPI_Datatype

foreign import ccall unsafe
        hmpi_datatype_ushort :: MPI_Datatype

foreign import ccall unsafe
        hmpi_datatype_int :: MPI_Datatype

foreign import ccall unsafe
        hmpi_datatype_unsigned :: MPI_Datatype

foreign import ccall unsafe
        hmpi_datatype_long :: MPI_Datatype

foreign import ccall unsafe
        hmpi_datatype_ulong :: MPI_Datatype

foreign import ccall unsafe
        hmpi_datatype_float :: MPI_Datatype

foreign import ccall unsafe
        hmpi_datatype_double :: MPI_Datatype


foreign import ccall unsafe
        hmpi_op_max :: MPI_Op

foreign import ccall unsafe
        hmpi_op_min :: MPI_Op

foreign import ccall unsafe
        hmpi_op_sum :: MPI_Op

foreign import ccall unsafe
        hmpi_op_prod :: MPI_Op

foreign import ccall unsafe
        hmpi_op_land :: MPI_Op

foreign import ccall unsafe
        hmpi_op_band :: MPI_Op

foreign import ccall unsafe
        hmpi_op_lor :: MPI_Op

foreign import ccall unsafe
        hmpi_op_bor :: MPI_Op

foreign import ccall unsafe
        hmpi_op_lxor :: MPI_Op

foreign import ccall unsafe
        hmpi_op_bxor :: MPI_Op

foreign import ccall unsafe
        hmpi_op_minloc :: MPI_Op

foreign import ccall unsafe
        hmpi_op_maxloc :: MPI_Op


foreign import ccall unsafe
        hmpi_compare_ident :: CInt

foreign import ccall unsafe
        hmpi_compare_congruent :: CInt

foreign import ccall unsafe
        hmpi_compare_similar :: CInt

foreign import ccall unsafe
        hmpi_compare_unequal :: CInt


foreign import ccall unsafe
        hmpi_undefined :: CInt


foreign import ccall unsafe
        hmpi_bottom :: MPI_Buffer a

        
-----------------------------------------------------------------------------
