{- $Id: MPI_Packet.hs,v 1.1.1.1 2001/02/28 04:48:04 michaelw Exp $
 - -*- Haskell -*-
 ----------------------------------------------------------------------------
 - MPI_Packet.hs - temporary concept
 ----------------------------------------------------------------------------
 - Created: 2000-10-08
 ----------------------------------------------------------------------------
 - NOTES:
 - * parts copied from Marshal.hs - Copyright (C) 1999  Sven Panne
 -   inspired by my initial proposal of semi-automatic `data' 
 -   marshalling
 ----------------------------------------------------------------------------
 - TODO:
 - * document this file properly
 - 
 ----------------------------------------------------------------------------
 -}

module MPI_Packet
    ( module MPI_Packet
    )
where

import MPI_MarshalInternal
import Monad 
    ( liftM
    , zipWithM_ )
import Foreign

----------------------------------------------------------------------
type SizeT = Int
-- A simple state monad, keeping track of the current buffer addr.
data Marshal a = Marshal { runMarshal :: forall b . Ptr b -> IO (a,Ptr b) }

instance Functor Marshal where
   fmap f p = Marshal (\a -> do (x,a') <- runMarshal p a
                                return (f x, a'))

instance Monad Marshal where
   return v = Marshal (\a -> return (v, a))
   p >>= f  = Marshal (\a -> do (x, a') <- runMarshal p a
                                runMarshal (f x) a')


runMarshal' :: Ptr b -> Marshal a -> IO a
runMarshal' ptr m = liftM fst (runMarshal m ptr)


getAddr :: Marshal (Ptr a)
getAddr = Marshal (\a -> return (castPtr a, a))


incAddr :: Int -> Marshal ()
incAddr i = Marshal (\a -> return ((), a `plusPtr` fromIntegral i))


-- monad transformer
iOToMarshal :: IO a -> Marshal a
iOToMarshal f = Marshal (\a -> do x <- f
                                  runMarshal (return x) a)


peekM :: Storable a => Marshal a
peekM = do
   a <- getAddr
   x <- iOToMarshal $! peek a
   incAddr (sizeOf x)
   return x


pokeM :: Storable a => a -> Marshal ()
pokeM x = do
   a <- getAddr
   iOToMarshal $! poke a x
   incAddr (sizeOf x)


-----------------------------------------------------------------------------
