{- $Id: MPI_Reduction.hs,v 1.1.1.2 2001/02/28 04:48:03 michaelw Exp $
 - -*- Haskell -*-
 -----------------------------------------------------------------------------
 - MPI_Reduction.hs - the MPI reduce operation and friends
 -----------------------------------------------------------------------------
 -
 - hMPI - a Haskell binding for MPI 1.1/1.2
 - Copyright (C) 2000,2001 Michael Weber <michael.weber@post.rwth-aachen.de>
 -
 - This library is free software; you can redistribute it and/or
 - modify it under the terms of the GNU Lesser General Public License
 - as published by the Free Software Foundation; either version 2 of
 - the License, or (at your option) any later version.
 - 
 - This library is distributed in the hope that it will be useful, but
 - WITHOUT ANY WARRANTY; without even the implied warranty of
 - MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 - Lesser General Public License for more details.
 - 
 - You should have received a copy of the GNU Lesser General Public
 - License along with this library; if not, write to the Free Software
 - Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 - USA
 - 
 -----------------------------------------------------------------------------
 - NOTES:                                                                      
 - 
 -----------------------------------------------------------------------------
 - TODO:                                                                       
 - * there are more functions like this...
 -
 - * document this file properly                                               
 -----------------------------------------------------------------------------
 -}

module MPI_Reduction
    ( reduce
    )
where

import MPI_Types
import MPI_CCalls
import MPI_MarshalInternal


------------------------------------------------------------------------------
reduce :: MPI_Buffer a -> MPI_Buffer a -> Int -> Datatype -> Op -> Rank -> Comm -> IO ()
reduce sendbuf recvbuf count dt op rank comm = safeCall_ (do
    mpi_Reduce sendbuf 
               recvbuf
               (fromIntegral count) 
               (marshalDatatype dt) 
               (marshalOp op) 
               (marshalRank rank)
               (marshalComm comm))


------------------------------------------------------------------------------
