{- $Id: MPI_SerializeMO.hs,v 1.1.1.2 2001/02/28 04:48:03 michaelw Exp $
 - -*- Haskell -*-
 -----------------------------------------------------------------------------
 - MPI_SerializeMO.hs - mutable object marshalling for the MPI binding
 -----------------------------------------------------------------------------
 -
 - hMPI - a Haskell binding for MPI 1.1/1.2
 - Copyright (C) 2000,2001 Michael Weber <michael.weber@post.rwth-aachen.de>
 -
 - This library is free software; you can redistribute it and/or
 - modify it under the terms of the GNU Lesser General Public License
 - as published by the Free Software Foundation; either version 2 of
 - the License, or (at your option) any later version.
 - 
 - This library is distributed in the hope that it will be useful, but
 - WITHOUT ANY WARRANTY; without even the implied warranty of
 - MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 - Lesser General Public License for more details.
 - 
 - You should have received a copy of the GNU Lesser General Public
 - License along with this library; if not, write to the Free Software
 - Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 - USA
 - 
 -----------------------------------------------------------------------------
 - NOTES:                                                                      
 -
 -----------------------------------------------------------------------------
 - TODO:                                                                       
 -
 -----------------------------------------------------------------------------
 -}

module MPI_SerializeMO
    ( module MPI_SerializeMO
    )
where

import MPI_Types (Datatype, Request)
import MPI_Serialize
import MPI_MarshalInternal

import Monad
import IOExts


-----------------------------------------------------------------------------
class Serialize a => SerializeMO m a where
    datatypeOfMO  :: m a -> Datatype
    sizeInElemsMO :: m a -> IO Int -- size in MPI units
    sizeInBytesMO :: m a -> IO Int

    serializeMO   :: m a -> IO (Buffer a)
    deserializeMO :: m a -> Int -> (Buffer a) -> IO ()


instance Serialize a => SerializeMO IORef a where
    datatypeOfMO x  = datatypeOf (unsafePerformIO (readIORef x)) -- not eval'd
    sizeInElemsMO x = liftM sizeInElems (readIORef x)
    sizeInBytesMO x = liftM sizeInBytes (readIORef x)

    serializeMO   ior           = readIORef  ior >>= serialize
    deserializeMO ior count ptr = writeIORef ior =<< deserialize count ptr


------------------------------------------------------------------------------
